# StunMessage Struct Reference

## Data Fields
StunMsgHdr | msgHdr
bool_t | hasMappedAddress
StunAtrAddress4 | mappedAddress
bool_t | hasResponseAddress
StunAtrAddress4 | responseAddress
bool_t | hasChangeRequest
StunAtrChangeRequest | changeRequest
bool_t | hasSourceAddress
StunAtrAddress4 | sourceAddress
bool_t | hasChangedAddress
StunAtrAddress4 | changedAddress
bool_t | hasUsername
StunAtrString | username
bool_t | hasPassword
StunAtrString | password
bool_t | hasMessageIntegrity
StunAtrIntegrity | messageIntegrity
bool_t | hasErrorCode
StunAtrError | errorCode
bool_t | hasUnknownAttributes
StunAtrUnknown | unknownAttributes
bool_t | hasReflectedFrom
StunAtrAddress4 | reflectedFrom
bool_t | hasRealm
StunAtrString | realmName
bool_t | hasNonce
StunAtrString | nonceName
bool_t | hasXorMappedAddress
StunAtrAddress4 | xorMappedAddress
bool_t | hasSoftware
StunAtrString | softwareName
bool_t | hasXorPeerAddress
StunAtrAddress4 | xorPeerAddress
bool_t | hasXorRelayedAddress
StunAtrAddress4 | xorRelayedAddress
bool_t | hasFingerprint
StunAtrFingerprint | fingerprint
bool_t | hasChannelNumberAttributes
TurnAtrChannelNumber | channelNumberAttributes
bool_t | hasLifetimeAttributes
TurnAtrLifetime | lifetimeAttributes
bool_t | hasData
TurnAtrData | data
bool_t | hasRequestedTransport
TurnAtrRequestedTransport | requestedTransport
bool_t | hasDontFragment
bool_t | hasReservationToken
TurnAtrReservationToken | reservationToken
bool_t | hasPriority
IceAtrPriority | priority
bool_t | hasUseCandidate
bool_t | hasIceControlled
IceAtrIceControll | iceControlled
bool_t | hasIceControlling
IceAtrIceControll | iceControlling

The documentation for this struct was generated from the following file:

- include/ortp/stun.h